using Edu.Common.Enum;
using Edu.Model.Entity.OKR;
using Edu.Model.ViewModel.OKR;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using VT.FW.DB.Dapper;

namespace Edu.Repository.OKR
{
    /// <summary>
    /// OKR更新历史仓储层
    /// </summary>
    public class RB_OKR_UpdateHistoryRepository : BaseRepository<RB_OKR_UpdateHistory>
    {

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_OKR_UpdateHistory_ViewModel> GetList(RB_OKR_UpdateHistory_ViewModel demodel)
        {
            string where = $@" 1=1 and Status =0";
            if (demodel.Group_Id > 0)
            {
                where += $@" and {nameof(RB_OKR_UpdateHistory.Group_Id)} ={demodel.Group_Id}";
            }
            if (demodel.Type > 0)
            {
                where += $@" and {nameof(RB_OKR_UpdateHistory.Type)} ={demodel.Type}";
            }
            if (demodel.SourceId > 0)
            {
                where += $@" and {nameof(RB_OKR_UpdateHistory.SourceId)} ={demodel.SourceId}";
            }

            string sql = $@" select * from RB_OKR_UpdateHistory where {where} order by Id desc";
            return Get<RB_OKR_UpdateHistory_ViewModel>(sql).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_OKR_UpdateHistory_ViewModel> GetPageList(int pageIndex,int pageSize,out long count,RB_OKR_UpdateHistory_ViewModel demodel)
        {
            string where = $@" 1=1 and Status =0";
            if (demodel.Group_Id > 0)
            {
                where += $@" and {nameof(RB_OKR_UpdateHistory.Group_Id)} ={demodel.Group_Id}";
            }
            if (demodel.Type > 0)
            {
                where += $@" and {nameof(RB_OKR_UpdateHistory.Type)} ={demodel.Type}";
            }
            if (demodel.SourceId > 0)
            {
                where += $@" and {nameof(RB_OKR_UpdateHistory.SourceId)} ={demodel.SourceId}";
            }

            string sql = $@" select * from RB_OKR_UpdateHistory where {where} order by Id desc";
            return GetPage<RB_OKR_UpdateHistory_ViewModel>(pageIndex, pageSize, out count, sql).ToList();
        }
    }
}
